package org.zipcoder.store;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

public class ListMap implements MyMap {
    // instance field that is intialize to an ArrayList
    private List<Entry> entries = new ArrayList<>();

    @Override
    public int size() {
        return entries.size();
    }

    @Override
    public boolean isEmptry() {
        if (size() == 0) return true;
        else return false;
    }

    @Override
    public Cart get(User key) {
        // find the cart associate with the key
        for (Entry e : entries) {
            if (e.getKey().equals(key)) {
                return e.getValue();
            }
        }
        return null;
    }

    @Override
    public void put(User key, Cart value) {
        // add the key, value entry to the entries list
        if (get(key) == null) entries.add(new Entry(key, value));
        else {
            for (Entry e : entries) {
                if (e.getKey().equals(key)) {
                    entries.remove(e);
                    e.setValue(value);
                    entries.add(e);
                }
            }
        }
    }


    @Override
    public List<User> getKeys() {
        // get all the keys in the map
        List<User> keySet = new ArrayList<User>();
        for (Entry e: entries) {
            keySet.add(e.getKey());
        }
        return keySet;
    }

    @Override
    public List<Cart> getValues() {
        // get all the values in the map
        List<Cart> valueSet = new ArrayList<Cart>();
        for (Entry e: entries) {
            valueSet.add(e.getValue());
        }
        return valueSet;
    }

    @Override
    public Cart remove(User key) {
        Cart removed = null;
        Iterator<Entry> iterator = entries.iterator();
        while (iterator.hasNext()) {
            Entry entry = iterator.next();
            if (entry.getKey().equals(key)) {
                removed = entry.getValue();
                iterator.remove();
            }
        }
        return removed;
    }
}
